

<!DOCTYPE html>
<html class="writer-html5" lang="ru" >
<head>
  <meta charset="utf-8" />
  
<!-- Yandex.Metrika counter -->
<script async="" src="https://mc.yandex.ru/metrika/tag.js"></script>
<script type="text/javascript">
	(function(m,e,t,r,i,k,a){m[i]=m[i]||function(){(m[i].a=m[i].a||[]).push(arguments)};
	m[i].l=1*new Date();k=e.createElement(t),a=e.getElementsByTagName(t)[0],k.async=1,k.src=r,a.parentNode.insertBefore(k,a)})
	(window, document, "script", "https://mc.yandex.ru/metrika/tag.js", "ym");
 
	ym(88079149, "init", {
		 clickmap:true,
		 trackLinks:true,
		 accurateTrackBounce:true,
		 webvisor:true
	});
 </script>
 <noscript><div><img src="https://mc.yandex.ru/watch/88079149" style="position:absolute; left:-9999px;" alt="" /></div></noscript>
 <!-- /Yandex.Metrika counter -->



  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>pyOpenRPA.Robot.Audio &mdash; документация pyOpenRPA v1.3.1 v1.3.1</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/translations.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Алфавитный указатель" href="../../../genindex.html" />
    <link rel="search" title="Поиск" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> pyOpenRPA v1.3.1
          

          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Поиск в документации" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">ОБЩЕЕ</span></p>
<ul>
<li class="toctree-l1"><a class="reference external" href="https://pyopenrpa.ru/wiki/guide/index">Выбрать версию</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../01_HowToInstall.html">1. Первый запуск (Windows &amp; Linux)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../03_Copyrights_Contacts.html">2. Лицензия &amp; Контакты</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ РОБОТ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/01_Robot.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/02_uidesktop.html">2. Функции UIDesktop</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/03_uiweb.html">3. Функции UIWeb</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/04_keyboard.html">4. Функции Keyboard</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/05_clipboard.html">5. Функции Clipboard</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/06_mouse.html">6. Функции Mouse</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/07_screen.html">7. Функции Screen</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/08_audio.html">8. Функции Audio</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/09_HowToUse.html">9. Как использовать?</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ СТУДИЯ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Studio/01_Studio.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Studio/02_HowToUse.html">2. Как использовать?</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ ОРКЕСТРАТОР</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/01_Orchestrator.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/02_Defs.html">2. Функции</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/03_gSettingsTemplate.html">3. Настройки GSettings (шаблон)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/04_HowToUse.html">4. Как использовать?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/05_UAC.html">5. Права доступа пользователей UAC</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ АГЕНТ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Agent/02_Defs.html">2. Функции Agent</a></li>
</ul>
<p class="caption"><span class="caption-text">ИНСТРУМЕНТЫ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Tools/02_Defs.html">2. Функции StopSafe</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">pyOpenRPA v1.3.1</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Код модуля</a> &raquo;</li>
        
      <li>pyOpenRPA.Robot.Audio</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Исходный код pyOpenRPA.Robot.Audio</h1><div class="highlight"><pre>
<span></span>
<span class="kn">from</span> <span class="nn">pyOpenRPA.Tools</span> <span class="kn">import</span> <span class="n">CrossOS</span>
<span class="k">if</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span><span class="p">:</span> <span class="kn">import</span> <span class="nn">pyaudio</span>
<span class="k">if</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span><span class="p">:</span> <span class="kn">from</span> <span class="nn">pydub</span> <span class="kn">import</span> <span class="n">AudioSegment</span>
<span class="kn">import</span> <span class="nn">threading</span>
<span class="kn">import</span> <span class="nn">time</span>
<span class="kn">from</span> <span class="nn">pyOpenRPA.Utils</span> <span class="kn">import</span> <span class="n">Text</span>
<span class="kn">import</span> <span class="nn">os</span>

<div class="viewcode-block" id="DeviceMicrophoneIndex"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.DeviceMicrophoneIndex">[документация]</a><span class="k">def</span> <span class="nf">DeviceMicrophoneIndex</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;L-,W+: Выполнить поиск устройства, с помощью которого можно будет выполнить захват c микрофона.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">p</span> <span class="o">=</span> <span class="n">pyaudio</span><span class="o">.</span><span class="n">PyAudio</span><span class="p">()</span>
    <span class="n">lDeviceInfoDict</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">get_default_input_device_info</span><span class="p">()</span>
    <span class="n">lDefaultIndexInt</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">lDefaultIndexInt</span></div>

<div class="viewcode-block" id="DeviceSystemSoundIndex"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.DeviceSystemSoundIndex">[документация]</a><span class="k">def</span> <span class="nf">DeviceSystemSoundIndex</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;L-,W+: Выполнить поиск устройства, с помощью которого можно будет выполнить захват аудио, которое поступает из приложений. Например: аудиоконференции Zoom, whatsapp, telegram и т.д.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">p</span> <span class="o">=</span> <span class="n">pyaudio</span><span class="o">.</span><span class="n">PyAudio</span><span class="p">()</span>
    <span class="n">inInputBool</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="n">inIsLoopbackBool</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="k">if</span> <span class="n">inInputBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
        <span class="n">lDeviceInfoDict</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">get_default_output_device_info</span><span class="p">()</span>
        <span class="n">lDefaultIndexInt</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">]</span>
        <span class="n">lDefaultNameStr</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span>
        <span class="n">lCatchIndexInt</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">lCatchDiffRatioFloat</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="k">for</span> <span class="n">lItemDict</span> <span class="ow">in</span> <span class="n">DeviceListGet</span><span class="p">():</span>
            <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">False</span>
            <span class="k">if</span> <span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;MaxOutputChannelsInt&quot;</span><span class="p">]</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">inIsLoopbackBool</span><span class="o">==</span><span class="kc">True</span> <span class="ow">and</span> <span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;HostApiStr&quot;</span><span class="p">]</span><span class="o">==</span><span class="s2">&quot;Windows WASAPI&quot;</span><span class="p">:</span> <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="k">elif</span> <span class="n">inIsLoopbackBool</span><span class="o">==</span><span class="kc">False</span><span class="p">:</span> <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">True</span>
            <span class="k">if</span> <span class="n">lCompareBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                <span class="n">lDiffRationFloat</span> <span class="o">=</span> <span class="n">Text</span><span class="o">.</span><span class="n">SimilarityNoCase</span><span class="p">(</span><span class="n">in1Str</span><span class="o">=</span><span class="n">lDefaultNameStr</span><span class="p">,</span> <span class="n">in2Str</span><span class="o">=</span><span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;NameStr&quot;</span><span class="p">])</span>
                <span class="k">if</span> <span class="n">lDiffRationFloat</span><span class="o">&gt;</span> <span class="n">lCatchDiffRatioFloat</span><span class="p">:</span> 
                    <span class="n">lCatchDiffRatioFloat</span> <span class="o">=</span> <span class="n">lDiffRationFloat</span>
                    <span class="n">lCatchIndexInt</span><span class="o">=</span><span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;IndexInt&quot;</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">lDeviceInfoDict</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">get_default_output_device_info</span><span class="p">()</span>
        <span class="n">lDefaultIndexInt</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">]</span>
        <span class="n">lDefaultNameStr</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span>
        <span class="n">lCatchIndexInt</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">lCatchDiffRatioFloat</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="k">for</span> <span class="n">lItemDict</span> <span class="ow">in</span> <span class="n">DeviceListGet</span><span class="p">():</span>
            <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">False</span>
            <span class="k">if</span> <span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;MaxInputChannelsInt&quot;</span><span class="p">]</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">inIsLoopbackBool</span><span class="o">==</span><span class="kc">True</span> <span class="ow">and</span> <span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;HostApiStr&quot;</span><span class="p">]</span><span class="o">==</span><span class="s2">&quot;Windows WASAPI&quot;</span><span class="p">:</span> <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="k">elif</span> <span class="n">inIsLoopbackBool</span><span class="o">==</span><span class="kc">False</span><span class="p">:</span> <span class="n">lCompareBool</span> <span class="o">=</span> <span class="kc">True</span>
            <span class="k">if</span> <span class="n">lCompareBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                <span class="n">lDiffRationFloat</span> <span class="o">=</span> <span class="n">Text</span><span class="o">.</span><span class="n">SimilarityNoCase</span><span class="p">(</span><span class="n">in1Str</span><span class="o">=</span><span class="n">lDefaultNameStr</span><span class="p">,</span> <span class="n">in2Str</span><span class="o">=</span><span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;NameStr&quot;</span><span class="p">])</span>
                <span class="k">if</span> <span class="n">lDiffRationFloat</span><span class="o">&gt;</span> <span class="n">lCatchDiffRatioFloat</span><span class="p">:</span> <span class="n">lCatchIndexInt</span><span class="o">=</span><span class="n">lItemDict</span><span class="p">[</span><span class="s2">&quot;IndexInt&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">lCatchIndexInt</span></div>

<div class="viewcode-block" id="DeviceListGet"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.DeviceListGet">[документация]</a><span class="k">def</span> <span class="nf">DeviceListGet</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;L-,W+: Вернуть список аудио устройст (входящих и исходящих, микрофонов и динамиков).</span>
<span class="sd">    </span>
<span class="sd">    from pyOpenRPA.Robot import Audio</span>
<span class="sd">    Audio.DeviceListGet()</span>

<span class="sd">    :return: [{&quot;IndexInt&quot;:1, &quot;NameStr&quot;: &quot;&quot;, </span>
<span class="sd">            &quot;HostApiInt&quot;: 0, &quot;HostApiStr&quot;: &quot;MME&quot;|&quot;Windows WASAPI&quot;|&quot;Windows WDM-KS&quot;,</span>
<span class="sd">            &quot;MaxInputChannelsInt&quot;: 0, &quot;MaxOutputChannelsInt&quot;: 0,</span>
<span class="sd">            &quot;DefaultSampleRateFloat&quot;: 44100.0</span>
<span class="sd">        },...]</span>
<span class="sd">    :rtype: list</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">l_result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">p</span> <span class="o">=</span> <span class="n">pyaudio</span><span class="o">.</span><span class="n">PyAudio</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">p</span><span class="o">.</span><span class="n">get_device_count</span><span class="p">()):</span>
        <span class="n">l_info</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">get_device_info_by_index</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
        <span class="n">l_info_dict</span> <span class="o">=</span> <span class="p">{</span>
            <span class="s2">&quot;IndexInt&quot;</span><span class="p">:</span><span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">],</span> 
            <span class="s2">&quot;NameStr&quot;</span><span class="p">:</span> <span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">],</span> 
            <span class="s2">&quot;MaxInputChannelsInt&quot;</span><span class="p">:</span> <span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;maxInputChannels&quot;</span><span class="p">],</span> 
            <span class="s2">&quot;MaxOutputChannelsInt&quot;</span><span class="p">:</span> <span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;maxOutputChannels&quot;</span><span class="p">],</span> 
            <span class="s2">&quot;HostApiInt&quot;</span><span class="p">:</span> <span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;hostApi&quot;</span><span class="p">],</span> 
            <span class="s2">&quot;DefaultSampleRateFloat&quot;</span><span class="p">:</span> <span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;defaultSampleRate&quot;</span><span class="p">],</span>
            <span class="s2">&quot;HostApiStr&quot;</span><span class="p">:</span> <span class="n">p</span><span class="o">.</span><span class="n">get_host_api_info_by_index</span><span class="p">(</span><span class="n">l_info</span><span class="p">[</span><span class="s2">&quot;hostApi&quot;</span><span class="p">])[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span> <span class="c1">#&quot;MME&quot;|&quot;Windows WASAPI&quot;|&quot;Windows WDM-KS&quot;</span>
        <span class="p">}</span>
        <span class="n">l_result</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">l_info_dict</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">l_result</span></div>

<div class="viewcode-block" id="Recorder"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder">[документация]</a><span class="k">class</span> <span class="nc">Recorder</span><span class="p">:</span>
    <span class="n">mStatusStr</span> <span class="o">=</span> <span class="s2">&quot;0_READY&quot;</span> <span class="c1"># &quot;0_READY&quot;, &quot;1_RECORDING&quot;</span>
    <span class="n">mAudio</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mCaptureThread</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mStream</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="n">mDeviceInt</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mChannelCountInt</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mFramesInt</span> <span class="o">=</span> <span class="mi">512</span>
    <span class="n">mRecordedFramesList</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">mSampleRateInt</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mSampleSizeInt</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="n">mCaptureBool</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="n">mFolderPathStr</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mFileNameStr</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mFileFormatStr</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mFileAvailableChunkInt</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mFileNameList</span><span class="o">=</span><span class="kc">None</span>

    <span class="n">mFileInfoDict</span><span class="o">=</span><span class="kc">None</span> <span class="c1"># {&quot;file.mp3&quot;:{StartSecFloat:, EndSecFloat:, Extra:,PathStr, }}</span>

    <span class="n">mChunkSecFloat</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="n">mStartSecFloat</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mStartChunkSecFloat</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mDurationSecFloat</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mThresholdInt</span> <span class="o">=</span> <span class="mi">500</span>

    <span class="n">mSilentLastCheckTimeFloat</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mIsMicrophoneBool</span><span class="o">=</span><span class="kc">None</span>
    
    <span class="n">mCallbackChunkDef</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mCallbackChunkDefThreadList</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">mCallbackStopDef</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">mCallbackStopDefThreadList</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inDeviceInt</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Инициализация экземпляра класса записи звука</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>

<span class="sd">        :param inDeviceInt: , по умолчанию None (использование устройства, полученного от DeviceSystemSoundIndex())</span>
<span class="sd">        :type inDeviceInt: int, опционально</span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">mDeviceInt</span> <span class="o">=</span> <span class="n">inDeviceInt</span>
        <span class="k">if</span> <span class="n">inDeviceInt</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span> <span class="n">inDeviceInt</span> <span class="o">=</span> <span class="n">DeviceSystemSoundIndex</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mDeviceInt</span> <span class="o">=</span> <span class="n">inDeviceInt</span>
        <span class="k">if</span> <span class="n">DeviceListGet</span><span class="p">()[</span><span class="n">inDeviceInt</span><span class="p">][</span><span class="s2">&quot;MaxInputChannelsInt&quot;</span><span class="p">]</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mIsMicrophoneBool</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">else</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mIsMicrophoneBool</span> <span class="o">=</span> <span class="kc">False</span>
    
<div class="viewcode-block" id="Recorder.StatusGet"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.StatusGet">[документация]</a>    <span class="k">def</span> <span class="nf">StatusGet</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Вернуть статус записи звука </span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.StatusGet()</span>

<span class="sd">        :return: &quot;0_READY&quot; или &quot;1_RECORDING&quot;</span>
<span class="sd">        :rtype: str</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">mStatusStr</span></div>

<div class="viewcode-block" id="Recorder.CaptureStart"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.CaptureStart">[документация]</a>    <span class="k">def</span> <span class="nf">CaptureStart</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inFolderPathStr</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span><span class="n">inFileNameStr</span> <span class="o">=</span> <span class="s2">&quot;out&quot;</span><span class="p">,</span> <span class="n">inFileFormatStr</span> <span class="o">=</span> <span class="s2">&quot;mp3&quot;</span><span class="p">,</span> <span class="n">inDurationSecFloat</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">inChunkSecFloat</span> <span class="o">=</span> <span class="mf">300.0</span><span class="p">,</span> <span class="n">inCallbackChunkDef</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">inCallbackStopDef</span> <span class="o">=</span> <span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Начать запись звука</span>

<span class="sd">        .. code-block:: python</span>

<span class="sd">            def CallbackChunk(lRec, lFilenameStr):</span>
<span class="sd">                pass # КОД ОБРАБОТКИ ПОСЛЕ СОХРАНЕНИЯ ЧАСТИ</span>

<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0, inCallbackChunkDef=CallbackChunk)</span>
<span class="sd">            lRec.CaptureStop()</span>

<span class="sd">        :param inFolderPathStr: Путь к папке, в которую сохранять аудиофайлы захвата , по умолчанию &quot;&quot;</span>
<span class="sd">        :type inFolderPathStr: str, опционально</span>
<span class="sd">        :param inFileNameStr: Наименование файла без расширения, по умолчанию &quot;out&quot;</span>
<span class="sd">        :type inFileNameStr: str, опционально</span>
<span class="sd">        :param inFileFormatStr: Наименование формата, в который будет происходить сохранение (&quot;mp3&quot; или &quot;wav&quot; или &quot;raw&quot; или &quot;aif&quot;), по умолчанию &quot;mp3&quot;</span>
<span class="sd">        :type inFileFormatStr: str, опционально</span>
<span class="sd">        :param inDurationSecFloat: Длительность захвата аудио, по умолчанию None (пока не поступит команда CaptureStop() )</span>
<span class="sd">        :type inDurationSecFloat: float, опционально</span>
<span class="sd">        :param inChunkSecFloat: Максимальная длина части аудиофайла, по умолчанию 300.0</span>
<span class="sd">        :type inChunkSecFloat: float, опционально</span>
<span class="sd">        :param inCallbackChunkDef: Функция, которая будет инициирована в случае выполнения Chunk сохранения (сохранение части). Callback функция должна принимать 2 аргумента: экземпляр класса Recorder и наименование сохраненного файла. Внимание! Функция запускается асинхронно!</span>
<span class="sd">        :type inCallbackChunkDef: def, опционально</span>
<span class="sd">        :param inCallbackStopDef: Функция, которая будет инициирована в случае окончания записи. Callback функция должна принимать 2 аргумента: экземпляр класса Recorder и наименование сохраненного файла. Внимание! Функция запускается асинхронно!</span>
<span class="sd">        :type inCallbackStopDef: def, опционально</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># CHECK AUX.mp3</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileInfoDict</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameList</span><span class="o">=</span><span class="p">[]</span>
        <span class="c1">#self.mRecordedFramesList=[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStatusStr</span> <span class="o">=</span> <span class="s2">&quot;1_RECORDING&quot;</span>
        <span class="k">if</span> <span class="n">inChunkSecFloat</span> <span class="o">!=</span> <span class="kc">None</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mDurationSecFloat</span> <span class="o">=</span> <span class="n">inDurationSecFloat</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mChunkSecFloat</span> <span class="o">=</span> <span class="n">inChunkSecFloat</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mSilentLastCheckTimeFloat</span><span class="o">=</span><span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFolderPathStr</span> <span class="o">=</span> <span class="n">inFolderPathStr</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameStr</span> <span class="o">=</span> <span class="n">inFileNameStr</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileFormatStr</span> <span class="o">=</span> <span class="n">inFileFormatStr</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mAudio</span> <span class="o">=</span> <span class="n">pyaudio</span><span class="o">.</span><span class="n">PyAudio</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mSampleSizeInt</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mAudio</span><span class="o">.</span><span class="n">get_sample_size</span><span class="p">(</span><span class="n">pyaudio</span><span class="o">.</span><span class="n">paInt16</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDef</span> <span class="o">=</span> <span class="n">inCallbackChunkDef</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDef</span> <span class="o">=</span> <span class="n">inCallbackStopDef</span>
        <span class="n">lDeviceInfoDict</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mAudio</span><span class="o">.</span><span class="n">get_device_info_by_index</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mDeviceInt</span><span class="p">)</span>
        <span class="c1">#Open stream</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mSampleRateInt</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;defaultSampleRate&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;maxInputChannels&quot;</span><span class="p">]</span> <span class="k">if</span> <span class="p">(</span><span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;maxOutputChannels&quot;</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;maxInputChannels&quot;</span><span class="p">])</span> <span class="k">else</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;maxOutputChannels&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStream</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mAudio</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="nb">format</span> <span class="o">=</span> <span class="n">pyaudio</span><span class="o">.</span><span class="n">paInt16</span><span class="p">,</span>
                        <span class="n">channels</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span><span class="p">,</span>
                        <span class="n">rate</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mSampleRateInt</span><span class="p">,</span>
                        <span class="nb">input</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
                        <span class="n">frames_per_buffer</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFramesInt</span><span class="p">,</span>
                        <span class="n">input_device_index</span> <span class="o">=</span> <span class="n">lDeviceInfoDict</span><span class="p">[</span><span class="s2">&quot;index&quot;</span><span class="p">],</span>
                        <span class="n">as_loopback</span> <span class="o">=</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">mIsMicrophoneBool</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureThread</span> <span class="o">=</span> <span class="n">threading</span><span class="o">.</span><span class="n">Thread</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">__Capture__</span><span class="p">,</span> <span class="n">daemon</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStartSecFloat</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStartChunkSecFloat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mStartSecFloat</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureThread</span><span class="o">.</span><span class="n">start</span><span class="p">()</span></div>

    <span class="k">def</span> <span class="nf">__Capture__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">while</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureBool</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mRecordedFramesList</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mStream</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mFramesInt</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">__TriggerCheck__</span><span class="p">()</span>

<div class="viewcode-block" id="Recorder.CaptureWait"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.CaptureWait">[документация]</a>    <span class="k">def</span> <span class="nf">CaptureWait</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inWaitCallbackChunkBool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span> <span class="n">inWaitCallbackStopBool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Ожидать окончания захвата аудио. Дополнительно настраивается ожидание окончания всех callback функций.</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = 10.0, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureWait()</span>

<span class="sd">        :param inWaitCallbackChunkBool: True - ожидать выполнение всех асинхронных callback по сохранению части аудиофайла, по умолчанию True</span>
<span class="sd">        :type inWaitCallbackChunkBool: bool, опционально</span>
<span class="sd">        :param inWaitCallbackStopBool: True - ожидать выполнение всех асинхронных callback по завершению записи, по умолчанию True</span>
<span class="sd">        :type inWaitCallbackStopBool: bool, опционально</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureThread</span><span class="o">.</span><span class="n">join</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">inWaitCallbackChunkBool</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lItemThread</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDefThreadList</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">lItemThread</span><span class="o">.</span><span class="n">is_alive</span><span class="p">():</span> <span class="n">lItemThread</span><span class="o">.</span><span class="n">join</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDefThreadList</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">if</span> <span class="n">inWaitCallbackStopBool</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lItemThread</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDefThreadList</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">lItemThread</span><span class="o">.</span><span class="n">is_alive</span><span class="p">():</span> <span class="n">lItemThread</span><span class="o">.</span><span class="n">join</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDefThreadList</span> <span class="o">=</span> <span class="p">[]</span></div>

<div class="viewcode-block" id="Recorder.CaptureStop"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.CaptureStop">[документация]</a>    <span class="k">def</span> <span class="nf">CaptureStop</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inWaitStream</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">inExtra</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Остановить захват аудио</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureStop()</span>

<span class="sd">        :param inWaitStream: True - выполнить ожидание окончания потока захвата перед окончанием, по умолчанию True</span>
<span class="sd">        :type inWaitStream: bool, опционально</span>
<span class="sd">        :param inExtra: Дополнительный контент, необходимый для идентификации файла. В дальнейшем получить структуру можно с помощью функции FileInfoGet()[&#39;Extra&#39;], по умолчанию None</span>
<span class="sd">        :type inExtra: any, опционально</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureBool</span><span class="o">=</span><span class="kc">False</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStream</span><span class="o">.</span><span class="n">stop_stream</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">inWaitStream</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCaptureThread</span><span class="o">.</span><span class="n">join</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStream</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="c1">#Close module</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mAudio</span><span class="o">.</span><span class="n">terminate</span><span class="p">()</span>
        <span class="n">lFileNameStr</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">CaptureChunk</span><span class="p">(</span><span class="n">inExtra</span><span class="o">=</span><span class="n">inExtra</span><span class="p">,</span> <span class="n">inForceChunkBool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStatusStr</span> <span class="o">=</span> <span class="s2">&quot;0_READY&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDef</span> <span class="o">!=</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">lCallbackThread</span> <span class="o">=</span> <span class="n">threading</span><span class="o">.</span><span class="n">Thread</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDef</span><span class="p">,</span><span class="n">args</span><span class="o">=</span><span class="p">[</span><span class="bp">self</span><span class="p">,</span> <span class="n">lFileNameStr</span><span class="p">],</span> <span class="n">daemon</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>
            <span class="n">lCallbackThread</span><span class="o">.</span><span class="n">start</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackStopDefThreadList</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">lCallbackThread</span><span class="p">)</span></div>
        
        
<div class="viewcode-block" id="Recorder.CaptureChunk"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.CaptureChunk">[документация]</a>    <span class="k">def</span> <span class="nf">CaptureChunk</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inExtra</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">inForceChunkBool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">inShiftSecFloat</span> <span class="o">=</span> <span class="mf">0.0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Зафиксировать захват аудио в виде промежуточного файла вида: &lt;имя файла&gt;_00000.mp3</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureChunk()</span>

<span class="sd">        :param inExtra: Дополнительный контент, необходимый для идентификации файла. В дальнейшем получить структуру можно с помощью функции FileInfoGet()[&#39;Extra&#39;], по умолчанию None</span>
<span class="sd">        :type inExtra: any, опционально</span>
<span class="sd">        :param inForceChunkBool: True - вне зависимости от текущего режима перейти на режим сохранения по частям, по умолчанию True</span>
<span class="sd">        :type inForceChunkBool: bool, опционально</span>
<span class="sd">        :param inShiftSecFloat: Последние секунды, которые не записывать в промежуточный аудиофайл. Они будут началом следующего аудио отрывка, по умолчанию 0.0</span>
<span class="sd">        :type inShiftSecFloat: float</span>
<span class="sd">        :return: Наименование сохраненного аудиофайла</span>
<span class="sd">        :rtype: str</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">inForceChunkBool</span><span class="o">==</span><span class="kc">True</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span><span class="o">==</span><span class="kc">None</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span><span class="o">=</span><span class="mi">0</span>
        <span class="n">lFileNameStr</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameStr</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span><span class="o">!=</span><span class="kc">None</span><span class="p">:</span> 
            <span class="n">lFileNameStr</span><span class="o">+=</span><span class="sa">f</span><span class="s2">&quot;_</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span><span class="si">:</span><span class="s2">05</span><span class="si">}</span><span class="s2">&quot;</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span> <span class="o">+</span> <span class="mi">1</span>
        <span class="n">lFileNameWExtStr</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">lFileNameStr</span><span class="si">}</span><span class="s2">.</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">mFileFormatStr</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="n">lFilePathStr</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mFolderPathStr</span><span class="p">,</span><span class="n">lFileNameWExtStr</span><span class="p">))</span>
        <span class="n">lDataFrameBytes</span> <span class="o">=</span> <span class="sa">b</span><span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mRecordedFramesList</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">inShiftSecFloat</span> <span class="o">!=</span> <span class="mf">0.0</span><span class="p">:</span> 
            <span class="n">lFrameLenInt</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mSampleSizeInt</span><span class="o">*</span><span class="n">inShiftSecFloat</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">mSampleRateInt</span><span class="p">)</span>
            <span class="n">lFrameLenInt</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">lFrameLenInt</span> <span class="o">//</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">mSampleSizeInt</span><span class="p">))</span> <span class="o">*</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">mSampleSizeInt</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">lFrameLenInt</span><span class="o">&lt;</span><span class="nb">len</span><span class="p">(</span><span class="n">lDataFrameBytes</span><span class="p">):</span> 
                <span class="bp">self</span><span class="o">.</span><span class="n">mRecordedFramesList</span><span class="o">=</span><span class="p">[</span><span class="n">lDataFrameBytes</span><span class="p">[</span><span class="o">-</span><span class="n">lFrameLenInt</span><span class="p">:]]</span>
                <span class="n">lDataFrameBytes</span> <span class="o">=</span> <span class="n">lDataFrameBytes</span><span class="p">[:</span><span class="o">-</span><span class="n">lFrameLenInt</span><span class="p">]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">lDataFrameBytes</span><span class="o">=</span><span class="sa">b</span><span class="s2">&quot;&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mRecordedFramesList</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># Advanced usage, if you have raw audio data:</span>
        <span class="n">sound</span> <span class="o">=</span> <span class="n">AudioSegment</span><span class="p">(</span>
            <span class="c1"># raw audio data (bytes)</span>
            <span class="n">data</span><span class="o">=</span><span class="n">lDataFrameBytes</span><span class="p">,</span>
            <span class="c1"># 2 byte (16 bit) samples</span>
            <span class="n">sample_width</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mSampleSizeInt</span><span class="p">,</span>
            <span class="c1"># 44.1 kHz frame rate</span>
            <span class="n">frame_rate</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mSampleRateInt</span><span class="p">,</span>
            <span class="c1"># stereo</span>
            <span class="n">channels</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mChannelCountInt</span>
        <span class="p">)</span>
        <span class="n">lTimeSecFloat</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span> <span class="o">-</span> <span class="n">inShiftSecFloat</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mFolderPathStr</span><span class="p">)):</span>
            <span class="n">os</span><span class="o">.</span><span class="n">mkdir</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mFolderPathStr</span><span class="p">)</span>
        <span class="n">sound</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="n">lFilePathStr</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">mFileFormatStr</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameList</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">lFileNameWExtStr</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mFileInfoDict</span><span class="p">[</span><span class="n">lFileNameWExtStr</span><span class="p">]</span><span class="o">=</span> <span class="p">{</span>
            <span class="s2">&quot;StartSecFloat&quot;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">mStartChunkSecFloat</span><span class="p">,</span> 
            <span class="s2">&quot;EndSecFloat&quot;</span><span class="p">:</span> <span class="n">lTimeSecFloat</span><span class="p">,</span> 
            <span class="s2">&quot;Extra&quot;</span><span class="p">:</span> <span class="n">inExtra</span><span class="p">,</span> 
            <span class="s2">&quot;PathStr&quot;</span><span class="p">:</span> <span class="n">lFilePathStr</span> 
        <span class="p">}</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDef</span> <span class="o">!=</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileAvailableChunkInt</span><span class="o">!=</span><span class="kc">None</span><span class="p">:</span>
            <span class="n">lCallbackThread</span> <span class="o">=</span> <span class="n">threading</span><span class="o">.</span><span class="n">Thread</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDef</span><span class="p">,</span><span class="n">args</span><span class="o">=</span><span class="p">[</span><span class="bp">self</span><span class="p">,</span> <span class="n">lFileNameWExtStr</span><span class="p">],</span> <span class="n">daemon</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>
            <span class="n">lCallbackThread</span><span class="o">.</span><span class="n">start</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mCallbackChunkDefThreadList</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">lCallbackThread</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mStartChunkSecFloat</span> <span class="o">=</span> <span class="n">lTimeSecFloat</span>
        <span class="k">return</span> <span class="n">lFileNameWExtStr</span></div>

<div class="viewcode-block" id="Recorder.FileInfoGet"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.FileInfoGet">[документация]</a>    <span class="k">def</span> <span class="nf">FileInfoGet</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inFileNameStr</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Вернуть информацию по аудиофайлу inFileNameStr. Если inFileNameStr == None -&gt; Функция вернет информацию по последнему записанному файлу</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureChunk()</span>
<span class="sd">            lFileInfoDict = lRec.FileInfoGet()</span>

<span class="sd">        :param inFileNameStr: Наименование аудиофайла с указанием расширения, по умолчанию None (взять последний записанный файл)</span>
<span class="sd">        :type inFileNameStr: str, опционально</span>
<span class="sd">        :return: {StartSecFloat:, EndSecFloat:, Extra:, PathStr:, } или None</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">inFileNameStr</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span> <span class="n">inFileNameStr</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">FileLastGet</span><span class="p">()</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileInfoDict</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">inFileNameStr</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span></div>

<div class="viewcode-block" id="Recorder.FileListGet"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.FileListGet">[документация]</a>    <span class="k">def</span> <span class="nf">FileListGet</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Вернуть список сохраненных аудиофайлов (наименования)</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureChunk()</span>
<span class="sd">            lRec.CaptureChunk()</span>
<span class="sd">            lRec.FileListGet()</span>

<span class="sd">        :return: [&quot;out_00000.mp3&quot;, &quot;out_00001.mp3&quot;, ...]</span>
<span class="sd">        :rtype: list</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameList</span></div>

<div class="viewcode-block" id="Recorder.FileLastGet"><a class="viewcode-back" href="../../../Robot/08_audio.html#pyOpenRPA.Robot.Audio.Recorder.FileLastGet">[документация]</a>    <span class="k">def</span> <span class="nf">FileLastGet</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;L-,W+: Вернуть наименование последнего сохраненного аудиофайла</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">            from pyOpenRPA.Robot import Audio</span>
<span class="sd">            lRec = Audio.Recorder()</span>
<span class="sd">            lRec.CaptureStart(inFileNameStr = &quot;out&quot;, inFileFormatStr = &quot;mp3&quot;, inDurationSecFloat = None, inChunkSecFloat = 5.0)</span>
<span class="sd">            lRec.CaptureChunk()</span>
<span class="sd">            lRec.CaptureChunk()</span>
<span class="sd">            lRec.FileListGet()</span>

<span class="sd">        :return: [&quot;out_00000.mp3&quot;, &quot;out_00001.mp3&quot;, ...]</span>
<span class="sd">        :rtype: list</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">mFileNameList</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span></div>
    
    <span class="c1">#def IsSilent(self, inLastSecFloat=None):</span>
    <span class="c1">#    &quot;Returns &#39;True&#39; if below the &#39;silent&#39; threshold&quot;</span>
    <span class="c1">#    self.mSilentLastCheckTimeFloat = time.time()</span>
    <span class="c1">#    if inLastSecFloat == None: inLastSecFloat = self.mChunkSilentSecFloat</span>
    <span class="c1">#    lFrameLenInt = int(self.mSampleSizeInt*inLastSecFloat)</span>
    <span class="c1">#    if lFrameLenInt&lt;len(self.mRecordedFramesList): lData = self.mRecordedFramesList[-lFrameLenInt:]</span>
    <span class="c1">#    else: lData = self.mRecordedFramesList</span>
    <span class="c1">#    return max(lData) &lt; self.mThresholdInt</span>
    
    <span class="k">def</span> <span class="nf">__TriggerCheck__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Контроль записи / остановки аудио по следующим критериям: </span>
<span class="sd">        - Общая длительность, </span>
<span class="sd">        - Максимальная длительность части, </span>
<span class="sd">        - Максимальная длит тишины (часть), </span>
<span class="sd">        - Максимальная длительность тишины (остановка), </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Проверка по длине записи (CHUNK)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mChunkSecFloat</span> <span class="o">!=</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">mStartChunkSecFloat</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">mChunkSecFloat</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">CaptureChunk</span><span class="p">()</span>
        <span class="c1"># Остановка записи по максимальной длине</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mDurationSecFloat</span> <span class="o">!=</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">mStartSecFloat</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">mDurationSecFloat</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">CaptureStop</span><span class="p">(</span><span class="n">inWaitStream</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span></div>
        <span class="c1"># Проверка тишины</span>
        <span class="c1">#if self.mChunkSilentSecFloat != None and time.time() - self.mSilentLastCheckTimeFloat and self.IsSilent(): self.mT.append(&quot;ТИШИНА!!&quot;)</span>

        
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2022, ООО &#34;ОПЕН РПА&#34;.

    </p>
  </div>
    
    
    
    Собрано при помощи <a href="https://www.sphinx-doc.org/">Sphinx</a> с использованием
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">темы,</a>
    
    предоставленной <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>